#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire900seven4xi .py">
#<abstract4xi abstract = "fires to direction seven and to distance 900"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire900seven4xi ']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2SEVEN - COORDINATE SIGNS OF SHOOT2SEVEN4XI: (X - ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2seven9004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2seven9004xi = {
                1:'-102x-425y786z',
                2:'-120x-788y417z',
                3:'-122x-412y790z',
                4:'-12x-469y768z',
                5:'-135x-854y246z',
                6:'-13x-16y899z',
                7:'-141x-397y794z',
                8:'-14x-118y891z',
                9:'-159x-382y798z',
                10:'-160x-776y425z',
                11:'-175x-366y803z',
                12:'-179x-844y254z',
                13:'-18x-109y893z',
                14:'-18x-24y899z',
                15:'-190x-349y807z',
                16:'-199x-763y433z',
                17:'-204x-332y811z',
                18:'-216x-314y814z',
                19:'-21x-32y899z',
                20:'-222x-831y263z',
                21:'-227x-296y818z',
                22:'-22x-99y894z',
                23:'-237x-277y822z',
                24:'-238x-747y441z',
                25:'-246x-258y825z',
                26:'-24x-41y898z',
                27:'-251x-46y862z',
                28:'-253x-240y829z',
                29:'-257x-61y860z',
                30:'-259x-221y832z',
                31:'-25x-89y895z',
                32:'-262x-77y857z',
                33:'-264x-202y836z',
                34:'-265x-815y272z',
                35:'-265x-93y854z',
                36:'-267x-183y839z',
                37:'-268x-110y851z',
                38:'-269x-128y848z',
                39:'-269x-164y842z',
                40:'-26x-50y898z',
                41:'-270x-146y845z',
                42:'-275x-729y449z',
                43:'-27x-60y897z',
                44:'-27x-69y896z',
                45:'-27x-79y896z',
                46:'-2x-137y889z',
                47:'-2x-2y899z',
                48:'-306x-798y280z',
                49:'-311x-710y456z',
                50:'-343x-290y779z',
                51:'-345x-688y464z',
                52:'-346x-778y289z',
                53:'-352x-266y783z',
                54:'-359x-243y788z',
                55:'-364x-220y792z',
                56:'-368x-197y796z',
                57:'-36x-460y772z',
                58:'-371x-174y800z',
                59:'-371x-347y860z',
                60:'-372x-151y805z',
                61:'-379x-665y472z',
                62:'-37x-804y401z',
                63:'-385x-756y297z',
                64:'-410x-640y479z',
                65:'-423x-732y306z',
                66:'-441x-614y487z',
                67:'-459x-707y314z',
                68:'-45x-869y228z',
                69:'-460x-773y2z',
                70:'-469x-586y494z',
                71:'-493x-679y323z',
                72:'-496x-557y502z',
                73:'-499x-748y11z',
                74:'-521x-527y509z',
                75:'-526x-650y331z',
                76:'-538x-721y20z',
                77:'-544x-495y517z',
                78:'-557x-619y339z',
                79:'-565x-463y524z',
                80:'-575x-691y29z',
                81:'-584x-430y531z',
                82:'-586x-586y348z',
                83:'-59x-449y777z',
                84:'-602x-396y539z',
                85:'-610x-660y38z',
                86:'-614x-552y356z',
                87:'-617x-361y546z',
                88:'-630x-325y553z',
                89:'-639x-517y364z',
                90:'-641x-290y560z',
                91:'-643x-627y47z',
                92:'-650x-254y567z',
                93:'-657x-217y574z',
                94:'-662x-181y581z',
                95:'-662x-481y372z',
                96:'-665x-145y588z',
                97:'-675x-592y56z',
                98:'-683x-444y381z',
                99:'-702x-405y389z',
                100:'-704x-555y65z',
                101:'-719x-366y397z',
                102:'-732x-517y74z',
                103:'-734x-326y405z',
                104:'-746x-286y413z',
                105:'-756x-245y421z',
                106:'-757x-478y82z',
                107:'-764x-204y429z',
                108:'-769x-163y437z',
                109:'-772x-122y445z',
                110:'-773x-81y452z',
                111:'-781x-437y91z',
                112:'-79x-797y409z',
                113:'-802x-395y100z',
                114:'-81x-438y781z',
                115:'-820x-352y109z',
                116:'-836x-308y118z',
                117:'-850x-264y127z',
                118:'-862x-219y136z',
                119:'-8x-128y890z',
                120:'-8x-8y899z',
                121:'-90x-863y237z',
                122:'0x-872y220z'}                   
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire900seven4xi " usage = "target function for charge2seven4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire900seven4xi (queue2seven, consumer_channel2seven, publisher_channel2seven):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE900SEVEN4XI - STARTED TIME: ", time2start)
        #  
        
        print("\n (STEP 1A2/33) OF FIRE900SEVEN4XI -  QUEUE2SEVEN: ", queue2seven)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE900SEVEN4XI -  CONSUMER_CHANNEL2SEVEN: ", consumer_channel2seven)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE900SEVEN4XI -  PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE900SEVEN4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2seven.put(shot2seven9004xi) 
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE900SEVEN4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE900SEVEN4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE900SEVEN4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2seven8shot2seven9004xi </ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2seven8shot2seven9004xi </nack2put4xi>" 
            
        publisher_channel2seven.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE900SEVEN4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE900SEVEN4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE900SEVEN4XI - RETURNING QUEUE OBJECT QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi())  
        # 
            
    return queue2seven    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire900seven4xi .py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

       